// This program is copyright VUW.
// You may not distribute it in any way without permission.

/* Code for COMP102 - 2019T2, Final Examination
 * Name:
 * Username:
 * ID:
 */

import ecs100.*;
import java.awt.Color;

/**
 * Complete this class on that specifies Ball objects.
 * 
 * The fields, and the draw() and erase() methods have been defined
 * for you.
 * 
 * Each ball should have the default start position at (100, 0), where
 * 100 is the centre of the x location of the ball and 0 is the y position
 * of the top of the slope.
 * 
 * The constructor should create a Ball object with the specified size,
 * speed and color. It should call the draw method to show the ball at
 * the default start position.
 * 
 * The move() method should move the ball downwards according to its speed.
 * It should not redraw it.
 * 
 * The getY() method should return the y position of the ball.
 * 
 * The setSpeed(...) method should update the speed of the ball.
 */

public class Ball {

    //Fields
    private double x;
    private double y;
    private double speed;
    private double size;
    private Color color;
    
    /**
     * Constructor to create a Ball.
     * 
     * @param size the size of the ball
     * @param speed the speed of the ball
     * @param color the color of the ball
     */
    public Ball(double size, double speed, Color color) {
        /*#YOUR CODE HERE*/
        this.size = size;
	this.speed = speed;
	this.color = color;
	this.draw();
	this.x = 100;
	this.y = 0;
        /*#END OF YOUR CODE*/
    
    }
    
    /**
     * Makes the ball move according to its speed.
     * 
     * Movement should only occur on in the y direction.
     */
    public void move(){
        /*#YOUR CODE HERE*/
        this.y = this.y + this.speed;
        /*#END OF YOUR CODE*/
       
    }
    
    /**
     * Gets this ball's y position
     */
    public double getY(){
        /*#YOUR CODE HERE*/
        return this.y;
        /*#END OF YOUR CODE*/
    
    }
    
    /**
     * Updates this ball's speed
     */
    public void setSpeed(double s){
        /*#YOUR CODE HERE*/
        this.speed = s;
        /*#END OF YOUR CODE*/
    
    }
    
    // These methods have been done for you
    /**
     * Draws the ball on the UI
     */
    public void draw(){
        UI.setColor(this.color);
	UI.fillOval(this.x-this.size/2, this.y-this.size, this.size, this.size);
    }
    
    /**
     * Erases the ball from the UI
     */
    public void erase(){
	UI.eraseOval(this.x-this.size/2, this.y-this.size, this.size, this.size);
    }
}    