// This program is copyright VUW.
// You may not distribute it in any way without permission.

/* Code for COMP102 - 2019T2, Final Examination
 * Name:
 * Username:
 * ID:
 */

import ecs100.*;
import java.awt.Color;
import java.util.ArrayList;

/**
 * Question 1. Basic Java                               [27 marks]
 * 
 * (a) [4 marks] Writing methods.
 * 
 *     Complete the method myMethod(...) below so that printStuff()
 *     prints out the example given below.
 *     
 *         printing stuff
 *         x=5 y=9
 *         z=45
 *         z=14
 *         
 * (b) [6 marks] Calling methods on objects.
 * 
 *     Given the Circle class, complete the useCircle() method below
 *     so that it:
 *       - makes a green circle at (100,150) with a size of 20
 *       - makes a red circle at (150, 200) with a size of 15
 *       - draws both circles on the screen
 *       - makes the first circle grow 3 times
 *       - makes second circle grow 2 times
 *       - shrinks the first circle 10 pixels
 *       - shrinks the second circle 2 pixels
 *       
 * (c) [8 marks] Arrays
 *   
 *     Complete the sumArray() method below so that it adds up all the numbers
 *     in the nums array (when testing your code, check that the answer is 27).
 *     
 *     
 * (d) [9 marks] ArrayLists
 * 
 *     Complete the countNegatives() method below so that it counts and prints
 *     the number of negative values that appear in the ArrayList of Doubles.
 *     
 *     For example, if the user enters "-1 8.8 -2.1 0 9 2 5",
 *     it should print "There were 2 negative numbers."
 */
public class Program1 {
    
    
    /**
     * (a). Calls myMethod(...) and prints things out.
     * 
     * DO NOT CHANGE THIS METHOD.
     * 
     * Calling this should print out the following:
     * 
     *     printing stuff
     *     x=5 y=9
     *     z=45
     *     z=14
     */
    public void printStuff() {
       UI.println("printing stuff");
       int x = 5;
       int y = 9;
       UI.println("x=" + x + " y=" + y);
       int z = x*y;
       UI.println("z=" + z);
       z = this.myMethod(x,y);
       UI.println("z=" + z);
    }
    
    /**
     * (a) Complete this method so that it computes the sum of its arguments
     */
    private int myMethod(int m, int n){
        /*# YOUR CODE HERE*/
        return m + n;
        /*# END OF YOUR CODE*/
        
    }
    
    /**
     * (b) Complete this method so that it:
     *       - makes a green circle at (100,150) with a size of 20
     *       - makes a red circle at (150, 200) with a size of 15
     *       - draws both circles on the screen
     *       - makes the first circle grow 3 times
     *       - makes second circle grow 2 times
     *       - shrinks the first circle 10 pixels
     *       - shrinks the second circle 2 pixels
     */
    public void useCircle(){
        /*# YOUR CODE HERE */
        Circle c1 = new Circle(100, 150, 20, Color.GREEN);
        Circle c2 = new Circle(150, 300, 15, Color.RED);
        c1.draw(); c2.draw();
        c1.grow(); c1.grow(); c1.grow();
        c2.grow(); c2.grow();
        c1.shrink(10);
        c2.shrink(2);
        /*# END OF YOUR CODE*/

    }
    
    /**
     * (c) Complete this method so that it adds up all the numbers in the nums array
     *     (when testing your code, check that the answer is 27).
     */
    public void sumArray(){
        int [ ] nums = new int [ ]{2, 6, 3, 4, 1, 2, 9, 0};
        int sum = 0;
        /*# YOUR CODE HERE */
        for(int n : nums) {
            sum += n;
        }
        /*# END OF YOUR CODE*/
    
        UI.println("The sum is: " + sum);
    }
    
    /**
     * (d) Complete this method so that it counts and prints the number of negative values
     * that appear in the ArrayList of Doubles stored in nums.
     * 
     * For example, if the user enters "-1 8.8 -2.1 0 9 2 5", it should print
     *     "There were 2 negative numbers."
     */
     public void countNegatives(){  
        ArrayList<Double> nums = UI.askNumbers("Enter numbers here: ");
        /*# YOUR CODE HERE */
        int count = 0;
        for (double d: nums){
            if (d < 0){
                count++;
            }
        }
        UI.println("There were " + count + " negative numbers");
        /*# END OF YOUR CODE*/
        
    }

    /*********************************************
     * YOU CAN IGNORE EVERYTHING BELOW THIS LINE *
     *********************************************/
    public void setupGUI() {
        UI.initialise();
        UI.addButton("(a) printStuff()", this::printStuff);
        UI.addButton("(b) useCircle()", this::useCircle);
        UI.addButton("(c) sumArray()", this::sumArray);
        UI.addButton("(d) countNegatives()", this::countNegatives);
        UI.setWindowSize(800,500);
        UI.setDivider(0.5);
    }
    
    public static void main(String[] args) {
        new Program1().setupGUI();
    }
}
