// This program is copyright VUW.
// You may not distribute it in any way without permission.

/* Code for COMP102 - 2019T2, Final Examination
 * Name:
 * Username:
 * ID:
 */

import ecs100.*;
import java.awt.Color;
import java.util.ArrayList;
import java.util.Scanner;
import java.io.File;
import java.io.IOException;

/**
 * Question 3. Files                                   [23 marks]
 * 
 * A file is shown below. Each line contains the definition of a
 * Shape (defined in the Shape class), and consists of:
 *   - the type of shape (a String)
 *   - the x position
 *   - the y position
 *   - the size
 *   - whether it is filled or not
 *   - and the color (as 3 integers, representing R G B)
 *   
 *          square 50 50 40 true 145 160 146
 *          circle 200 50 50 true 0 125 186
 *          triangle 200 200 75 true 227 66 52
 *          square 250 100 90 false 204 204 255
 *          circle 100 100 50 false 47 132 124
 *          triangle 100 400 75 false 255 128 255
 *          ...
 *          
 *  Complete the run() and processLine(...) methods below so that they
 *  will read the file, create a Shape object for each line in the file,
 *  and draw the shape on the screen.
 *  
 *  The name of the data file is data.txt.
 *  The output should look like the image in the handout.
 * 
 */
public class Program3 {

    /**
     * This method reads the lines for the file and then processes them to create a shape.
     * 
     * It should draw all the shapes as they are made.
     */
    public void run() {
        UI.clearGraphics();
        
        try {
            Scanner scan = new Scanner(new File("data.txt"));
            /*# YOUR CODE HERE */
            while(scan.hasNextLine()) {
                Shape s = processLine(scan.nextLine());
                s.draw();
            }
            /*# END OF YOUR CODE */
        
        } catch (IOException e) {
            UI.println("Error opening file: " + e.getMessage());
        }
    } 
    
    /**
     *  This method reads the information from the provided scanner to
     *  create and return a shape.
     *  
     *  The format for a shape is as follows:
     *  
     *    - The type (String)
     *    - x position (double)
     *    - y position (double)
     *    - size (double)
     *    - filled (boolean)
     *    - red (int)
     *    - green (int)
     *    - blue (int)
     *    
     *    The last three values represent the color of the shape.
     */
    public Shape processLine(String line) {
        /*# YOUR CODE HERE */
        Scanner scan = new Scanner(line);
        String type = scan.next();
        double x = scan.nextDouble();
        double y = scan.nextDouble();
        double size = scan.nextDouble();
        boolean filled = scan.nextBoolean();
        int r = scan.nextInt();
        int g = scan.nextInt();
        int b = scan.nextInt();
        return new Shape(type, x, y, size, filled, new Color(r,g,b));
        /*# END OF YOUR CODE */
        
    }
    
    /*********************************************
     * YOU CAN IGNORE EVERYTHING BELOW THIS LINE *
     *********************************************/
    public void setupGUI() {
        UI.initialise();
        UI.addButton("Run", this::run);
        UI.setWindowSize(500,500);
        UI.setDivider(0.0);
        UI.setLineWidth(4);
    }
    
    public static void main(String[] args) {
        new Program3().setupGUI();
    }
}
